"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const injection_1 = require("injection");
const constant_1 = require("../constant");
const utils_1 = require("../utils");
function logger(identifier) {
    return function (target, targetKey, index) {
        if (typeof index === 'number') {
            utils_1.attachConstructorDataOnClass(identifier, target, constant_1.LOGGER_KEY, index);
        }
        else {
            if (!identifier) {
                identifier = targetKey;
            }
            injection_1.attachClassMetadata(constant_1.LOGGER_KEY, {
                key: identifier,
                propertyName: targetKey
            }, target);
        }
    };
}
exports.logger = logger;
//# sourceMappingURL=logger.js.map