"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const injection_1 = require("injection");
const constant_1 = require("./constant");
function attachConstructorDataOnClass(identifier, clz, type, index) {
    if (!identifier) {
        const args = injection_1.getParamNames(clz);
        if (clz.length === args.length && index < clz.length) {
            identifier = args[index];
        }
    }
    // save constructor index on class
    let constructorMetaValue = injection_1.getClassMetadata(constant_1.CLASS_KEY_CONSTRUCTOR, clz);
    if (!constructorMetaValue) {
        constructorMetaValue = {};
    }
    constructorMetaValue[index] = {
        key: identifier,
        type
    };
    injection_1.saveClassMetadata(constant_1.CLASS_KEY_CONSTRUCTOR, constructorMetaValue, clz);
}
exports.attachConstructorDataOnClass = attachConstructorDataOnClass;
//# sourceMappingURL=utils.js.map