interface GetFileStreamOptions {
    requireFile?: boolean;
    defCharset?: string;
    limits?: {
        fieldNameSize?: number;
        fieldSize?: number;
        fields?: number;
        fileSize?: number;
        files?: number;
        parts?: number;
        headerPairs?: number;
    };
    checkFile?(fieldname: string, file: any, filename: string, encoding: string, mimetype: string): void | Error;
}
interface GetFilesStreamOptions extends GetFileStreamOptions {
    autoFields?: boolean;
}
export declare enum RouteParamTypes {
    QUERY = 0,
    BODY = 1,
    PARAM = 2,
    HEADERS = 3,
    SESSION = 4,
    FILESTREAM = 5,
    FILESSTREAM = 6,
    NEXT = 7
}
export interface RouterParamValue {
    index?: number;
    type?: RouteParamTypes;
    data?: any;
    extractValue?: (ctx: any, next: any) => Promise<any>;
}
export declare const extractValue: (key: any, data: any) => (ctx: any, next: any) => Promise<any>;
export declare const session: () => (target: any, key: any, index: any) => void;
export declare const body: (property?: string) => (target: any, key: any, index: any) => void;
export declare const query: (property?: string) => (target: any, key: any, index: any) => void;
export declare const param: (property?: string) => (target: any, key: any, index: any) => void;
export declare const headers: (property?: string) => (target: any, key: any, index: any) => void;
export declare const file: (property?: GetFileStreamOptions) => (target: any, key: any, index: any) => void;
export declare const files: (property?: GetFilesStreamOptions) => (target: any, key: any, index: any) => void;
export {};
